routes/web.php
<?php

use App\Http\Controllers\Contracts\ContractController;
use App\Http\Controllers\Estimates\EstimateController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\Roles\RoleController;
use App\Http\Controllers\Services\ServiceController;
use App\Http\Controllers\SubTours\SubTourController;
use App\Http\Controllers\Tours\TourController;
use App\Http\Controllers\Users\UserController;
use App\Http\Controllers\Commissions\CommissionController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect('login');
});

Auth::routes();

Route::get('/home', [HomeController::class, 'index'])
    ->name('home')
    ->middleware('auth');

Route::group(['middleware' => 'auth'], function() {
    Route::name('tours.')->prefix('tours')->group(function () {
        Route::get('/', [TourController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:tour-list');
        Route::get('/create', [TourController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:tour-create');
        Route::post('/', [TourController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:tour-create');
        Route::get('/edit/{id}', [TourController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:tour-edit');
        Route::put('/{id}', [TourController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:tour-edit');
        Route::delete('/{id}', [TourController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:tour-delete');
        Route::get('/show/{id}', [TourController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:tour-list');
        Route::get('/search', [TourController::class, 'search'])
            ->name('search');
    });
    Route::name('users.')->prefix('users')->group(function () {
        Route::get('/', [UserController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:user-list');
        Route::get('/create', [UserController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:user-create');
        Route::post('/', [UserController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:user-create');
        Route::get('/edit/{id}', [UserController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:user-edit');
        Route::put('/{id}', [UserController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:user-edit');
        Route::delete('/{id}', [UserController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:user-delete');
        Route::get('/show/{id}', [UserController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:user-list');
        Route::get('/search', [UserController::class, 'search'])
            ->name('search');
    });
    Route::name('services.')->prefix('services')->group(function () {
        Route::get('/', [ServiceController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:service-list');
        Route::get('/create', [ServiceController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:service-create');
        Route::post('/', [ServiceController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:service-create');
        Route::get('/edit/{id}', [ServiceController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:service-edit');
        Route::put('/{id}', [ServiceController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:service-edit');
        Route::delete('/{id}', [ServiceController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:service-delete');
        Route::get('/show/{id}', [ServiceController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:service-list');
    });
    Route::name('roles.')->prefix('roles')->group(function () {
        Route::get('/', [RoleController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:role-list');
        Route::get('/create', [RoleController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:role-create');
        Route::post('/', [RoleController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:role-create');
        Route::get('/edit/{id}', [RoleController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:role-edit');
        Route::put('/{id}', [RoleController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:role-edit');
        Route::delete('/{id}', [RoleController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:role-delete');
        Route::get('/show/{id}', [RoleController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:role-list');
        Route::get('/search', [RoleController::class, 'search'])
            ->name('search');
    });
    Route::name('subTours.')->prefix('subTours')->group(function () {
        Route::get('/', [SubTourController::class, 'index'])
            ->name('index');
        Route::get('/create', [SubTourController::class, 'create'])
            ->name('create');
        Route::post('/', [SubTourController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [SubTourController::class, 'edit'])
            ->name('edit');
        Route::put('/{id}', [SubTourController::class, 'update'])
            ->name('update');
        Route::delete('/{id}', [SubTourController::class, 'destroy'])
            ->name('destroy');
        Route::get('/show/{id}', [SubTourController::class, 'show'])
            ->name('show');
        Route::get('/search', [SubTourController::class, 'search'])
            ->name('search');
    });

    Route::name('estimates.')->prefix('estimates')->group(function () {
        Route::get('subTour/{subTourId}', [EstimateController::class, 'index'])
            ->name('index');
        Route::get('/create', [EstimateController::class, 'create'])
            ->name('create');
        Route::post('/', [EstimateController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [EstimateController::class, 'edit'])
            ->name('edit');
        Route::put('/{id}', [EstimateController::class, 'update'])
            ->name('update');
        Route::delete('/{id}', [EstimateController::class, 'destroy'])
            ->name('destroy');
        Route::get('/show/{id}', [EstimateController::class, 'show'])
            ->name('show');
        Route::get('/search', [EstimateController::class, 'search'])
            ->name('search');
        Route::get('/export/{id}', [EstimateController::class, "export"])
            ->name("export");
    });

    Route::name('contracts.')->prefix('contracts')->group(function () {
        Route::get('subTour/{subTourId}', [ContractController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:contract-list');
        Route::get('subTour/{subTourId}/create', [ContractController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:contract-create');
        Route::post('/', [ContractController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [ContractController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:contract-edit');
        Route::put('/{id}', [ContractController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:contract-edit');
        Route::delete('/{id}', [ContractController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:contract-delete');
        Route::get('/show/{id}', [ContractController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:contract-list');
        Route::get('/search', [ContractController::class, 'search'])
            ->name('search');
        Route::get('/createContract/{id}', [ContractController::class, "createContractFile"])
            ->name("createContractFile");
        Route::get('/contract/{contractId}/history', [ContractController::class, "history"])
            ->name("history");
    });
    Route::name('commissions.')->prefix('commissions')->group(function () {
        Route::get('contract/{contractId}', [CommissionController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:contract-list');
        Route::get('contract/{contractId}/create', [CommissionController::class, 'create'])
            ->name('create');
        Route::post('/', [CommissionController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [CommissionController::class, 'edit'])
            ->name('edit');
        Route::put('/{id}', [CommissionController::class, 'update'])
            ->name('update');
        Route::delete('/{id}', [CommissionController::class, 'destroy'])
            ->name('destroy');

app/Models/Tour.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Tour extends Model
{
    use HasFactory;

    protected $table = 'tours';

    protected $fillable = [
        'name',
        'content',
        'start_location',
        'destination_location',
        'create_by',
        'tour_code',
        'tour_type'
    ];

    public function scopeWithName($query, $name)
    {
        return $name ? $query->where('name', 'LIKE', '%' . $name. '%') : null;
    }

    public function services()
    {
        return $this->belongsToMany(Service::class, 'tour_has_services', 'tour_id', 'service_id');
    }

    public function attachService($serviceId)
    {
        return $this->services()->attach($serviceId);
    }

    public function syncService($serviceId)
    {
        return $this->services()->sync($serviceId);
    }

    public function detachService()
    {
        $this->services()->detach();
    }

    public function getTourServiceId($id)
    {
        return $this->services()->where('tour_id', $id)->pluck('service_id');
    }

    public function subTour()
    {
        return $this->hasMany('App\Models\SubTour');
    }

    public function search($key)
    {
        return Tour::where('tour_code', 'LIKE', '%' . $key. '%')->latest('id')->paginate(5);
    }
}

app/Http/Controllers/Tours/TourController.php
<?php

namespace App\Http\Controllers\Tours;

use App\Http\Controllers\Controller;
use App\Models\Tour;
use App\Services\ServiceService;
use App\Services\TourService;
use Illuminate\Http\Request;

class TourController extends Controller
{
    protected $tourService;
    protected $serviceService;
    protected $tour;

    public function __construct(TourService $tourService, ServiceService $serviceService, Tour $tour)
    {
        $this->tourService = $tourService;
        $this->serviceService = $serviceService;
        $this->tour = $tour;
    }

    public function index()
    {
        $tours = $this->tourService->index();
        return view('admin.tours.index', compact('tours'));
    }

    public function create()
    {
        $services = $this->serviceService->getAllService();
        return view('admin.tours.create', compact('services'));
    }

    public function store(Request $request)
    {
        $this->tourService->create($request);
        return redirect()->route('tours.index');
    }

    public function show(int $id)
    {
        $tour = $this->tourService->show($id);
        return view('admin.tours.show', compact('tour'));
    }

    public function edit($id)
    {
        $tour = $this->tourService->findById($id);
        $services = $this->serviceService->getAllService();
        $serviceIds = $this->tourService->getTourServiceId($id);
        return view('admin.tours.edit', compact('tour', 'services', 'serviceIds'));
    }

    public function update(Request $request, int $id)
    {
        $this->tourService->update($request, $id);
        return redirect()->route('tours.index');
    }

    public function destroy($id)
    {
        $this->tourService->destroy($id);
        return redirect()->route('tours.index');
    }

    public function search(Request $request)
    {
        $key = $request->input('key') ?? '';
        $result = $this->tour->search($key);
        return view('admin.tours.index', ['tours' => $result]);
    }
}

resources/views/admin/tours/create.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>Create Tour</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <div class="container-fluid px-4">
                <h1 class="mt-4">Create Tour</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ url()->previous() }}">Back>></a>
                </ol>
                <div class="container">
                    <div class="row justify-content-center">
                        <form action="{{route('tours.store')}}" method="POST" enctype="multipart/form-data">
                            @csrf
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Name</label>
                                    <input name="name" type="text" class="form-control"
                                           placeholder="Tour Name...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Content</label>
                                    <input name="content" type="text" class="form-control"
                                           placeholder="Content...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Start Location</label>
                                    <input name="start_location" type="text" class="form-control"
                                           placeholder="Start Location...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Destination Location</label>
                                    <input name="destination_location" type="text" class="form-control"
                                           placeholder="Destination Location...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Tour Code</label>
                                    <input name="tour_code" type="text" class="form-control"
                                           placeholder="Tour Code...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Create By</label>
                                    <input name="create_by" type="text" class="form-control"
                                           placeholder="Create By...">
                                </div>
                            </div>
                            <label class="form-label">Service</label>
                            <div class="mb-3">
                                <input class="form-check-input" type="checkbox" id="checkAll">
                                <label class="form-label">Select All</label>
                                <div class="row">
                                @foreach($services as $service)
                                    <div class="col-md-3 mt-3">
                                        <input class="form-check-input" type="checkbox"
                                               name="service[]"
                                               value="{{ $service->id }}">
                                        <label class="form-check-label" for="flexCheckDefault">
                                            {{ $service->name }}
                                        </label>
                                    </div>
                                @endforeach
                                </div>
                            </div>
                            <button type="submit" class="btn btn-success" >Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </main>
    </div>
    <script>
        $("#checkAll").click(function () {
            $('input:checkbox').not(this).prop('checked', this.checked);
        });
    </script>
@endsection

resources/views/admin/tours/edit.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>Update Tour</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <div class="container-fluid px-4">
                <h1 class="mt-4">Update Tour</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ url()->previous() }}">Back>></a>
                </ol>
                <div class="container">
                    <div class="row justify-content-center">
                        <form action="{{route('tours.update', $tour->id)}}" method="POST" enctype="multipart/form-data">
                            @method('PUT')
                            @csrf
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Name</label>
                                    <input name="name" type="text" class="form-control"
                                           placeholder="Tour Name..." value="{{ $tour->name }}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Content</label>
                                    <input name="content" type="text" class="form-control"
                                              placeholder="Content..." value="{{ $tour->content }}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Start Location</label>
                                    <input name="start_location" type="text" class="form-control"
                                           placeholder="Start Location..." value="{{ $tour->start_location }}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Destination Location</label>
                                    <input name="destination_location" type="text" class="form-control"
                                           placeholder="Destination Location..." value="{{ $tour->destination_location }}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Tour Code</label>
                                    <input name="tour_code" type="text" class="form-control"
                                           placeholder="Tour Code..." value="{{ $tour->tour_code }}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Create By</label>
                                    <input name="create_by" type="text" class="form-control"
                                           placeholder="Create By..." value="{{ $tour->create_by }}">
                                </div>
                            </div>
                            <label class="form-label">Service</label>
                            <div class="mb-3">
                                <input class="form-check-input" type="checkbox" id="checkAll">
                                <label class="form-label">Select All</label>
                                <div class="row">
                                    @foreach($services as $service)
                                        <div class="col-md-3 mt-3">
                                            <input {{$serviceIds->contains($service->id) ? 'checked' : ''}} class="form-check-input" type="checkbox"
                                                   name="service[]"
                                                   value="{{ $service->id }}">
                                            <label class="form-check-label" for="flexCheckDefault">
                                                {{ $service->name }}
                                            </label>
                                        </div>
                                    @endforeach
                                </div>
                            </div>
                            <button type="submit" class="btn btn-success">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </main>
    </div>
    <script>
        $("#checkAll").click(function () {
            $('input:checkbox').not(this).prop('checked', this.checked);
        });
    </script>
@endsection

resources/views/admin/tours/index.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>Tour Management</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <h1></h1>
            <div class="container-fluid px-4">
                <h1 class="mt-4">Tour Management</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ route('home') }}">HomePage</a>
                </ol>
                <div class="row mt-5">
                    <form action="{{ route('tours.search') }}" class="input-group col-9" method="GET" style="margin-left: 4%">
                        <input type="search" class="form-control rounded col-5" placeholder="Search" name="key" />
                        <button type="submit" class="btn btn-outline-primary ml-2 col-1">search</button>
                    </form>
                    <div class="col-2" style="margin-left: 4%">
                        <a href="{{ route('tours.create') }}" class="btn btn-success col-5">
                            <i class="fas fa-plus-circle"></i>&nbsp;Create
                        </a>
                    </div>
                </div>
            </div>
            <div class="d-flex justify-content-center">
                <table class="table table-bordered mt-5" style="width: 90% !important;">
                <thead>
                <tr align="center">
                    <th scope="col">Order</th>
                    <th scope="col">Name</th>
                    <th scope="col">Content</th>
                    <th scope="col">Start Location</th>
                    <th scope="col">Destination Location</th>
                    <th scope="col">Create By</th>
                    <th scope="col">Tour Code</th>
                    <th scope="col">Service</th>
                    <th scope="col" style="width:15% !important">Action</th>
                </tr>
                </thead>
                <tbody align="center">
                @foreach($tours as $key => $tour)
                    <tr>
                        <td scope="row">{{$key+1}}</td>
                        <td scope="row">{{$tour->name}}</td>
                        <td scope="row">{{$tour->content}}</td>
                        <td scope="row">{{$tour->start_location}}</td>
                        <td scope="row">{{$tour->destination_location}}</td>
                        <td scope="row">{{$tour->create_by}}</td>
                        <td scope="row">{{$tour->tour_code}}</td>
                        <td scope="row">
                            @forelse($tour->services as $service)
                                <span class="badge bg-secondary">{{$service->name}}</span>
                            @empty
                                <span><b>This tour doesn't have service</b></span>
                            @endforelse
                        </td>
                        <td>
                            <a href="{{route('tours.show', $tour->id)}}" class="btn btn-primary"><i
                                    class="far fa-eye"></i></a>
                            <a href="{{route('tours.edit', $tour->id)}}" class="btn btn-success"><i
                                    class="far fa-edit"></i></a>
                            <button type="submit" class="btn btn-danger btn-delete" onclick="deleteTour({{$tour->id}})"><i
                                    class="fas fa-trash-alt"></i></button>
                            <form action="{{route('tours.destroy', $tour->id)}}" id="form-{{$tour->id}}" method="POST">
                                @method('DELETE')
                                @csrf
                            </form>
                        </td>
                    </tr>
                @endforeach
                </tbody>
            </table>
            </div>
            <div class="container-fluid" style="display: flex; justify-content: end; margin-left: -4%;">
                {{$tours->links()}}
            </div>
@endsection
@push('scripts')
    <script>
        function deleteTour(id)
        {
            Swal.fire({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
                if (result.isConfirmed) {
                    event.preventDefault();
                    document.getElementById('form-' + id).submit();
                    Swal.fire(
                        'Deleted!',
                        'Your file has been deleted.',
                        'success'
                    )
                }
            })
        }
    </script>
@endpush

resources/views/admin/tours/show.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>Tour Detail</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <h1></h1>
            <div class="container-fluid px-4">
                <h1 class="mt-4">Tour Detail</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ url()->previous() }}">Back>></a>
                </ol>
                <div class="container-fluid px-4">
                    <input type="search" name="name" value="{{ request('name') }}" class="form-control"
                           placeholder="search ...">
                </div>
            </div>
            <table class="table table-striped">
                <thead>
                <tr align="center">
                    <th scope="col">ID</th>
                    <th scope="col">Name</th>
                    <th scope="col">Content</th>
                    <th scope="col">Start Location</th>
                    <th scope="col">Destination Location</th>
                    <th scope="col">Create By</th>
                    <th scope="col">Tour Code</th>
                    <th scope="col">Service</th>
                    <th scope="col">Action</th>
                </tr>
                </thead>
                <tbody align="center">
                    <tr>
                        <td scope="row">{{$tour->id}}</td>
                        <td scope="row">{{$tour->name}}</td>
                        <td scope="row">{{$tour->content}}</td>
                        <td scope="row">{{$tour->start_location}}</td>
                        <td scope="row">{{$tour->destination_location}}</td>
                        <td scope="row">{{$tour->create_by}}</td>
                        <td scope="row">{{$tour->tour_code}}</td>
                        <td scope="row">
                            @forelse($tour->services as $service)
                                <span class="badge bg-secondary">{{$service->name}}</span>
                            @empty
                                <span><b>This tour doesn't have service</b></span>
                            @endforelse
                        </td>
                        <td>
                            <form action="{{route('tours.destroy', $tour->id)}}" method="POST">
                                @method('DELETE')
                                @csrf
                                <a href="{{route('tours.show', $tour->id)}}" class="btn btn-primary"><i
                                        class="far fa-eye"></i></a>
                                <a href="{{route('tours.edit', $tour->id)}}" class="btn btn-success"><i
                                        class="far fa-edit"></i></a>
                                <button type="submit" class="btn btn-danger btn-delete" data-action=""><i
                                        class="fas fa-trash-alt"></i></button>
                            </form>
                        </td>
                    </tr>
                </tbody>
            </table>
        </main>
    </div>
@endsection